package com.framework.mvvm.model.db.entity

import androidx.room.ColumnInfo
import androidx.room.Entity
import androidx.room.PrimaryKey
import kotlinx.serialization.Serializable

/**
 * 关系配置 表
 */
@Entity(tableName = "rel_config")
@Serializable
data class RelConfigEntity(
    @PrimaryKey val id: String,
    @ColumnInfo(name = "obj_type_from") val objTypeFrom: String?,      // from 端对象类型(space|equipment)
    @ColumnInfo(name = "obj_type_to") val objTypeTo: String?,          //  to  端对象类型(space|equipment)
    @ColumnInfo(name = "class_code_from") val classCodeFrom: String?,  // from 端对象class_code
    @ColumnInfo(name = "class_code_to") val classCodeTo: String?,      //  to  端对象class_code
    @ColumnInfo(name = "graph_code") val graphCode: String?,           // 关系的图类型代码
    @ColumnInfo(name = "graph_name") val graphName: String?,           // 关系的图类型名称
    @ColumnInfo(name = "rel_code") val relCode: String?,               // 关系的边类型代码
    @ColumnInfo(name = "rel_name") val relName: String?,               // 关系的边类型代码
)
